Download it now!
Bug 56344 - CUPS timeout and automatic reconnect
Summary: CUPS timeout and automatic reconnect
Status: RESOLVED WORKSFORME
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Printing and PDF export (show other bugs)
Version:
(earliest affected)
3.6.2.2 release
Hardware: Other Linux (All)
: medium normal
Assignee: Not Assigned
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2012-10-24 06:44 UTC by franco.violi
Modified: 2015-06-08 16:55 UTC (History)
6 users (show)

See Also:
Crash report or crash signature:


Attachments
Force reconnection to CUPS server on print failure (1.59 KB, patch)
2012-12-13 08:22 UTC, Alex Prokofiev
Details

Note You need to log in before you can comment on or make changes to this bug.
Description franco.violi 2012-10-24 06:44:12 UTC
On Linux system, cups has a timeout of 300 seconds by default. When you print from OpenOffice the first time, everything is ok. If you wait more then 300 seconds and then try to print again, nothing happen. When nothing happen, go into the printer dialog and you will get an empty list. Increasing at infinity the cups timeout, you have no problem but this cannot be the solution.

If you drop the cups option using the printer admin dialog, everything is fine.
Comment 1 Volker Helm 2012-11-06 14:53:34 UTC
I've got a similar problem also.

libreoffice 3.5.4  kubuntu 12.04 i386.

My libreoffice loses cups connection after around 5 min. All printers are shown, but doesn't print including cups-pdf printer.

I supposed the printers are shown through /home/<user>/.cups/client.conf with 'ServerName <someprintserver>'

Since we're using cups on regular basis we are hoping for a solution.
Comment 2 Volker Helm 2012-11-13 17:36:17 UTC
Looks a lot like Bug 50784 

https://bugs.freedesktop.org/show_bug.cgi?id=50784
Comment 3 Valentin Höbel 2012-11-16 08:28:47 UTC
Also sounds like:
https://bugs.launchpad.net/ubuntu/+source/libreoffice/+bug/1020048

We can confirm this issue and also that the workaround with a higher timeout value for CUPS works.
Our details:
Ubuntu 12.04 64 Bit
3.2.0-33-generic #52-Ubuntu SMP
Libre Office 3.6.0~rc4-0ubuntu3~ppa1~precise1

We performed a debugging session yesterday and observed that Libre Office looses the connection to the CUPS server within 5 minutes:

- tshark on the CUPS server, observing the connection close:
353.291104 192.168.1.1 -> 192.168.1.115 IPP 245 IPP response
353.291352 192.168.1.115 -> 192.168.1.1 TCP 66 52363 > 631 [ACK] Seq=7064 Ack=45384 Win=42272 Len=0 TSval=8393025 TSecr=8563624
  [no further packages]
384.142218 192.168.1.1 -> 192.168.1.115 TCP 66 631 > 52363 [FIN, ACK] Seq=45384 Ack=7064 Win=33792 Len=0 TSval=8571337 TSecr=8393025
384.178858 192.168.1.115 -> 192.168.1.1 TCP 66 52363 > 631 [ACK] Seq=7064 Ack=45385 Win=42272 Len=0 TSval=8400747 TSecr=8571337

- Other actions of Libre Office will be answered with a connection reset:
406.177739 192.168.1.115 -> 192.168.1.1 TCP 221 [TCP segment of a reassembled PDU]
406.177767 192.168.1.1 -> 192.168.1.115 TCP 54 631 > 52363 [RST] Seq=45385 Win=0 Len=0
406.177840 192.168.1.115 -> 192.168.1.1 IPP 341 IPP request
406.177851 192.168.1.1 -> 192.168.1.115 TCP 54 631 > 52363 [RST] Seq=45385 Win=0 Len=0

- From this point of time on, Libre Office "knows" that there is no connection with the CUPS server and doesn't open a new one.

- stracing shows the second printing attempt:
27989 18:35:53 sendto(35, "POST /printers/lp16 HTTP/1.1\r\nContent-Length: 275\r\nContent-Type: application/ipp\r\nHost: myhost.mydomain.tld\r\nUser-Agent: CUPS/1.5.3\r\nExpect: 100-continue\r\n\r\n", 155, 0, NULL, 0) = 155
27989 18:35:53 sendto(35, "\1\1\0\5\0\0\0\1\1G\0\22attributes-charset\0\5utf-8H\0\33attributes-natural-language\0\5de-deE\0\vprinter-uri\0!ipp://localhost:631/printers/lp16B\0\24requesting-user-name\0\6myusernameB\0\10job-name\0\nUnbenannt1I\0\17document-format\0\30app"..., 275, 0, NULL, 0) = 275
27989 18:35:53 poll([{fd=35, events=POLLIN}], 1, 1000) = 1 ([{fd=35, revents=POLLIN}])
27989 18:35:53 poll([{fd=35, events=POLLIN}], 1, 60000) = 1 ([{fd=35, revents=POLLIN}])
27989 18:35:53 recvfrom(35, "", 2048, 0, NULL, NULL) = 0
Comment 4 Alex Prokofiev 2012-12-13 08:22:03 UTC
Created attachment 71432 [details]
Force reconnection to CUPS server on print failure

I've got the same bug when printing stops after 5 mins.
Attached patch solves this problem for LibreOffice by dropping old
connection and retrying on print error.

Closing old connection is done with cupsSetServer(NULL)
Comment 5 Francisco Javier 2013-01-16 00:14:45 UTC
I have Libreoffice 3.6.4.3 in gentoo and after 5 minuts stop printing.. my clients in schools same problem.


Add TimeOut 9000 in cupsd.conf solves half :-(
Comment 6 Steve Wilson 2013-01-31 19:40:10 UTC
Any news of when this might be fixed?  Increasing the CUPS timeout apparently caused problems with Acrobat Reader so that's not an option for us.  That leaves me with telling the users that, if they want to print, they need to either print within five minutes of opening LibreOffice or restart LibreOffice.  Not too good... :-)

Thanks!

Steve
Comment 7 Owen Genat (retired) 2013-05-28 15:15:54 UTC
Is this still an issue? As pointed out up thread it appears to be the same one as reported in bug #50784 and over on Ubuntu Launchpad. The Launchpad bug appears to indicate that CUPS v1.6.2 (2013-03-18) included a patch that specifically addressed this problem:

https://bugs.launchpad.net/ubuntu/+source/libreoffice/+bug/1020048/comments/34

Does anyone know if this fixed the LO issue reported here? Perhaps this can be RESOLVED as NOTOURBUG?
Comment 8 haenig 2013-08-19 07:58:12 UTC
For me (libreoffice 3.6.3.2.4 (openSuSE 12.3) it still is a problem.

For which version one could assume the patch from comment 4 beeing included?

This "... Perhaps this can be RESOLVED as NOTOURBUG? ... "
from comment 7 I can _NOT_ second, because if one follows 
https://bugs.launchpad.net/ubuntu/+source/libreoffice/+bug/1020048/comments/33

and subsequently uses the systems default print dialogue the issue disappears (by circumventing ). So for me it is rather IDEEDOURBUG ;-)
Comment 9 haenig 2013-08-19 08:28:23 UTC
After installing the latest (from openSuSE build service) version 4.0.3.3.5 I can confitm the persistance of the bug for this version too.
Comment 10 Owen Genat (retired) 2013-08-19 08:35:07 UTC
In response to comment #8 and comment #9, which version of CUPS are you running? According to this link OpenSUSE 12.3 include CUPS v1.5.4:

http://software.opensuse.org/package/cups

My comment (and those of others) was a suggestion that CUPS v1.6.2 fixes the issue. Does the build service version of OpenSUSE include the newer version of CUPS? If the problem persists with CUPS v1.6.2+ then I think we need to change the bug status from UNCONFIRMED to NEW.
Comment 11 Owen Genat (retired) 2013-08-19 08:41:18 UTC
Sorry for the noise, it appears that the original fix to CUPS is in need of a second patch according to this comment on 2013-07-18:

https://bugs.launchpad.net/ubuntu/+source/libreoffice/+bug/1020048/comments/37
Comment 12 haenig 2013-08-19 08:48:46 UTC
The "solution" to not use libreoffices print dialogue is rather no solution too because then the behaviour is much more annoying because when simply wanting to open the print dialogue via 'file' => 'print' (and the timeout has already hit) LO crashes and the open document gets printed without any possibility to prevent it or influence the settings. :-(
Comment 13 Owen Genat (retired) 2013-12-21 23:00:26 UTC
Summary amended to more clearly reflect the issue. Status set to NEW as a result of comment #3 and comment #4. The issue now appears to have finally been fixed in CUPS v1.7.0. In the download cups-1.7.0-source.tar.gz the cups-1.7.0\CHANGES.txt file states:

> httpGetFd, httpGetFile, httpPutFd, and httpPutFile did not
> automatically reconnect if the server closed the connecion after the
> previous response.

This would appear to be the reconnection issue mentioned in comment 37 and 44 in the related LaunchPad bug. If others could test against this version of CUPS to see if the problem persists it would be much appreciated.

(In reply to comment #12)
> The "solution" to not use libreoffices print dialogue is rather no solution

The text from comment 33 in the LaunchPad issue never proposed this as a solution. It was proposed as a workaround i.e., a way to temporarily get past the problem.
Comment 14 haenig 2014-01-09 14:15:53 UTC
Today I have been able to test my (OpenSuSE 12.3's) LibreOffice 4.1.4.2 against cups 1.7.1

Several attempts succeeded. So for me I would say the problem is gone.
Comment 15 Koehler 2014-05-02 08:44:47 UTC
Usin
Debian wheezy LO 4.1.3.2, cups 1.5.3
with standard cups.conf (Port 631, Timeout 300, etc) I had no printing problems. When I dropped from cups.conf the directive
Listen /var/run/cups/cups.sock
LO lost connection to cups printers as described in this thread.
So, at least in GNU/Linux the socket provides a work around.
Comment 16 bfoman (inactive) 2014-06-04 22:03:35 UTC
Back to NEW as change to ASSIGNED was not explained. In fact, could this be marked as RESOLVED WORKSFORME per comment 14 and comment 15?
Comment 17 QA Administrators 2015-06-08 14:43:12 UTC
** Please read this message in its entirety before responding **

To make sure we're focusing on the bugs that affect our users today, LibreOffice QA is asking bug reporters and confirmers to retest open, confirmed bugs which have not been touched for over a year.

There have been thousands of bug fixes and commits since anyone checked on this bug report. During that time, it's possible that the bug has been fixed, or the details of the problem have changed. We'd really appreciate your help in getting confirmation that the bug is still present.

If you have time, please do the following:

   Test to see if the bug is still present on a currently supported version of LibreOffice (4.4.3 or later)
   https://www.libreoffice.org/download/

   If the bug is present, please leave a comment that includes the version of LibreOffice and your operating system, and any changes you see in the bug behavior
 
 If the bug is NOT present, please set the bug's Status field to RESOLVED-WORKSFORME and leave a short comment that includes your version of LibreOffice and Operating System

Please DO NOT

   Update the version field
   Reply via email (please reply directly on the bug tracker)
   Set the bug's Status field to RESOLVED - FIXED (this status has a particular meaning that is not appropriate in this case)


If you want to do more to help you can test to see if your issue is a REGRESSION. To do so: 1. Download and install oldest version of LibreOffice (usually 3.3 unless your bug pertains to a feature added after 3.3)

http://downloadarchive.documentfoundation.org/libreoffice/old/

2. Test your bug 
3. Leave a comment with your results;
4a. If the bug was present with 3.3 - set version to "inherited from OOo"; 
4b. If the bug was not present in 3.3 - add "regression" to keyword


Feel free to come ask questions or to say hello in our QA chat: http://webchat.freenode.net/?channels=libreoffice-qa

Thank you for your help!

-- The LibreOffice QA Team This NEW Message was generated on: 2015-06-08
Comment 18 Philipp Wagner 2015-06-08 16:55:59 UTC
This has been fixed in cups version 1.6.4 (from the changes.txt: "Closed server connections were still not always detected (<rdar://problem/14484313>)")

Since quite some time I have not seen this problem any more on recent openSUSE or Ubuntu versions, so let's consider this fixed for now.